=== added file 'src/com/goldencode/p2j/util/OutputTableParameter.java'
--- old/src/com/goldencode/p2j/util/OutputTableParameter.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/util/OutputTableParameter.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,168 @@
+/*
+** Module   : OutputTableParameter.java
+** Abstract : OUTPUT TABLE parameter support.
+**
+** Copyright (c) 2013-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210430 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.util;
+
+import com.goldencode.p2j.persist.*;
+
+/**
+ * Implements the OUTPUT TABLE parameter type. This hard codes the input/output flags and delegates
+ * all other processing to the parent class.
+ */
+public class OutputTableParameter
+extends TableParameter
+{
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    */
+   public OutputTableParameter(Temporary table)
+   {
+      super(table, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public OutputTableParameter(Temporary table, ParameterOption option)
+   {
+      super(table, option);
+   }
+   
+   /**
+    * Create an instance.
+    *
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    */
+   public OutputTableParameter(handle tableHandle)
+   {
+      super(tableHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance.
+    *
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public OutputTableParameter(handle tableHandle, ParameterOption option)
+   {
+      super(tableHandle, option);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    */
+   public OutputTableParameter(TableWrapper resultSet)
+   {
+      super(resultSet, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public OutputTableParameter(TableWrapper resultSet, ParameterOption option)
+   {
+      super(resultSet, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code false}.
+    */
+   @Override
+   public boolean isInputMode()
+   {
+      return false;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   @Override
+   public boolean isOutputMode()
+   {
+      return true;
+   }
+}

=== modified file 'src/com/goldencode/p2j/util/ParameterOption.java'
--- old/src/com/goldencode/p2j/util/ParameterOption.java	2019-06-30 21:10:34 +0000
+++ new/src/com/goldencode/p2j/util/ParameterOption.java	2022-05-12 15:03:49 +0000
@@ -3,10 +3,11 @@
 ** Abstract : Declares the parameter options for passing complex data structures (TABLEs and
 **            DATASETs and their handles).
 **
-** Copyright (c) 2019, Golden Code Development Corporation.
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 OM  20190522 Created initial version.
+** 002 GES 20210430 Added APPEND member.
 */
 
 /*
@@ -66,8 +67,8 @@
 /**
  * This enum declares the parameter passing options for complex data structures (TABLE, DATASET,
  * TABLE-HANDLE and DATASET-HANDLE for both parameter declaration and parameter passing.
- * The enum is generated in both {@link com.goldencode.p2j.persist.DataSetParameter} and
- * {@link TableParameter} as optional parameter in constructor.
+ * The enum is used in both {@link com.goldencode.p2j.persist.DataSetParameter} and
+ * {@link TableParameter} as an optional parameter in the constructor.
  */
 public enum ParameterOption
 {
@@ -77,12 +78,15 @@
     */
    NONE,
    
+   /** Data is appended instead of being referenced or replaced. */
+   APPEND,
+   
    /** The structure is passed by reference (see {@code BY-REFERENCE} mode). */
    BY_REFERENCE,
    
-   /** The structure is binded (see {@code BIND} mode). */
+   /** The structure is bound (see {@code BIND} mode). */
    BIND,
    
-   /** The structure is passed by reference (see {@code BY-VALUE} mode). */
+   /** The structure is passed by value (see {@code BY-VALUE} mode). */
    BY_VALUE
 }

=== modified file 'src/com/goldencode/p2j/util/TableParameter.java'
--- old/src/com/goldencode/p2j/util/TableParameter.java	2021-11-25 13:43:19 +0000
+++ new/src/com/goldencode/p2j/util/TableParameter.java	2022-05-12 15:03:49 +0000
@@ -1,6 +1,6 @@
 /*
 ** Module   : TableParameter.java
-** Abstract : Container for table handle and calling-side APPEND option.
+** Abstract : Parameter support for TABLE and TABLE-HANDLE.
 **
 ** Copyright (c) 2013-2021, Golden Code Development Corporation.
 **
@@ -26,6 +26,7 @@
 **     SVL 20210517 Fixed isValid() for the case of a result set.
 **     CA  20211125 Fixed an issue when the TABLE-HANDLE handle is not unknown, but invalid - getTable() must
 **                  return null.
+**     GES 20210430 Reworked to enable subclasses which reduce parameter processing from common use cases.
 */
 
 /*
@@ -86,10 +87,16 @@
 import com.goldencode.p2j.persist.*;
 
 /**
- * Container for table handle and calling-side APPEND option. Serves two purposes: 1. passes
- * calling-side APPEND option to the called side; 2. implements interchangeability between TABLE
- * and TABLE-HANDLE parameters (In 4GL you can pass TABLE parameter to a procedure that takes
- * TABLE-HANDLE and vice versa).
+ * Represents a table or table-handle parameter, the mode (INPUT, INPUT-OUTPUT or OUTPUT) and any table
+ * parameter options (APPEND, BY-VALUE, BIND or BY-REFERENCE).  Allows subclasses to specialize this
+ * behavior.  A core feature is to implement interchangeability between TABLE and TABLE-HANDLE parameters
+ * (in the 4GL you can pass a TABLE parameter to a procedure that takes TABLE-HANDLE and vice versa).
+ * <p>
+ * The parameter mode can be implemented in this class or it can be overridden in a subclass.  If it is
+ * implemented here, then the input and output flags must be passed to the constructor.  If the subclass
+ * overrides the {@link #isInputMode} and {@link #isOutputMode} methods then the input and output boolean
+ * members will be ignored.  This is sub-optimal but it was done deliberately to enable the base class to
+ * be used as a full replacement for any of the subclasses.
  */
 public class TableParameter
 {
@@ -99,11 +106,8 @@
    /** Table handle. */
    private final handle tableHandle;
    
-   /** Corresponds calling-side APPEND option. */
-   private final boolean append;
-   
-   /** Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option. */
-   private final ParameterOption mode;
+   /** Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE). */
+   private final ParameterOption option;
    
    /** Calling- or called-side result set (for remote parameters). */
    private TableWrapper resultSet = null;
@@ -111,6 +115,12 @@
    /** Determines if this is a remote (passed to appserver) parameter. */
    private boolean remoteParameter = false;
    
+   /** {@code true} if the parameter mode is INPUT or INPUT-OUTPUT. */
+   private boolean input = false;
+   
+   /** {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT. */
+   private boolean output = false;
+   
    /**
     * 1-based index of the table parameter (in declaration of the function). <code>0</code>
     * if it is not defined.
@@ -120,82 +130,88 @@
    /**
     * Create an instance using a buffer.
     *
-    * @param table
-    *        Buffer of the wrapped table.
+    * @param    table
+    *           Buffer of the wrapped table.
     */
    public TableParameter(Temporary table)
    {
-      this(table, false, ParameterOption.NONE);
-   }
-   
-   /**
-    * Create an instance using a buffer.
-    *
-    * @param table
-    *        Buffer of the wrapped table.
-    * @param append
-    *        Determines if APPEND option was specified on the calling side.
-    */
-   public TableParameter(Temporary table, boolean append)
-   {
-      this(table, append, ParameterOption.NONE);
-   }
-   
-   /**
-    * Create an instance using a buffer.
-    *
-    * @param   table
-    *          Buffer of the wrapped table.
-    * @param   append
-    *          Determines if APPEND option was specified on the calling side.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
-    */
-   public TableParameter(Temporary table, boolean append, ParameterOption mode)
-   {
-      this.table = (Temporary) ((BufferImpl) table).ref();
+      this(table, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public TableParameter(Temporary table, ParameterOption option)
+   {
+      this(table, option, false, false);
+   }
+   
+   /**
+    * Create an instance using a buffer.
+    *
+    * @param    table
+    *           Buffer of the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    * @param    input
+    *           {@code true} if the parameter mode is INPUT or INPUT-OUTPUT.
+    * @param    output
+    *           {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT.
+    */
+   public TableParameter(Temporary table, ParameterOption option, boolean input, boolean output)
+   {
+      this.table       = (Temporary) ((BufferImpl) table).ref();
       this.tableHandle = ((BufferReference) table).buffer().tableHandle();
-      this.append = append;
-      this.mode = mode;
+      this.option      = option;
+      this.input       = input;
+      this.output      = output;
    }
    
    /**
     * Create an instance using a table handle.
     *
-    * @param tableHandle
-    *        Handle to the wrapped table.
+    * @param    tableHandle
+    *           Handle to the wrapped table.
     */
    public TableParameter(handle tableHandle)
    {
-      this(tableHandle, false, ParameterOption.NONE);
+      this(tableHandle, ParameterOption.NONE);
    }
    
    /**
     * Create an instance using a table handle.
     *
-    * @param tableHandle
-    *        Handle to the wrapped table.
-    * @param append
-    *        Determines if APPEND option was specified on the calling side.
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
     */
-   public TableParameter(handle tableHandle, boolean append)
+   public TableParameter(handle tableHandle, ParameterOption option)
    {
-      this(tableHandle, append, ParameterOption.NONE);
+      this(tableHandle, option, false, false);
    }
    
    /**
     * Create an instance using a table handle.
     *
-    * @param   tableHandle
-    *          Handle to the wrapped table.
-    * @param   append
-    *          Determines if APPEND option was specified on the calling side.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
+    * @param    tableHandle
+    *           Handle to the wrapped table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    * @param    input
+    *           {@code true} if the parameter mode is INPUT or INPUT-OUTPUT.
+    * @param    output
+    *           {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT.
     */
-   public TableParameter(handle tableHandle, boolean append, ParameterOption mode)
+   public TableParameter(handle tableHandle, ParameterOption option, boolean input, boolean output)
    {
       WrappedResource res = tableHandle.getResource();
+      
       if (tableHandle._isValid())
       {
          if (res instanceof TempTable)
@@ -220,41 +236,56 @@
       }
       
       this.tableHandle = tableHandle;
-      this.append = append;
-      this.mode = mode;
-   }
-   
-   /**
-    * Create an instance using a result set (for remote parameters).
-    *
-    * @param resultSet
-    *        Result set containing input data.
-    * @param append
-    *        Determines if APPEND option was specified on the calling side.
-    */
-   public TableParameter(TableWrapper resultSet, boolean append)
-   {
-      this(resultSet, append, ParameterOption.NONE);
-   }
-   
-   /**
-    * Create an instance using a result set (for remote parameters).
-    *
-    * @param   resultSet
-    *          Result set containing input data.
-    * @param   append
-    *          Determines if APPEND option was specified on the calling side.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
-    */
-   public TableParameter(TableWrapper resultSet, boolean append, ParameterOption mode)
-   {
-      this.table = null;
-      this.tableHandle = new handle();
-      this.resultSet = resultSet;
-      this.append = append;
-      this.mode = mode;
+      this.option      = option;
+      this.input       = false;
+      this.output      = false;
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    */
+   public TableParameter(TableWrapper resultSet)
+   {
+      this(resultSet, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public TableParameter(TableWrapper resultSet, ParameterOption option)
+   {
+      this(resultSet, option, false, false);
+   }
+   
+   /**
+    * Create an instance using a result set (for remote parameters).
+    *
+    * @param    resultSet
+    *           Result set containing input data.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    * @param    input
+    *           {@code true} if the parameter mode is INPUT or INPUT-OUTPUT.
+    * @param    output
+    *           {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT.
+    */
+   public TableParameter(TableWrapper resultSet, ParameterOption option, boolean input, boolean output)
+   {
+      this.table           = null;
+      this.tableHandle     = new handle();
+      this.resultSet       = resultSet;
+      this.option          = option;
       this.remoteParameter = true;
+      this.input           = input;
+      this.output          = output;
       
       // if INPUT, create a dynamic table
       if (resultSet.isInput() && !resultSet.isFromJson() && resultSet.isAfterTable())
@@ -276,10 +307,52 @@
    }
    
    /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   {@code true} if this is INPUT or INPUT-OUTPUT.
+    */
+   public boolean isInputMode()
+   {
+      return input;
+   }
+
+   /**
+    * Set the flag for whether this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @param    input
+    *           {@code true} if this is INPUT or INPUT-OUTPUT.
+    */
+   public void setInputMode(boolean input)
+   {
+      this.input = input;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   {@code true} if this is OUTPUT or INPUT-OUTPUT.
+    */
+   public boolean isOutputMode()
+   {
+      return output;
+   }
+   
+   /**
+    * Set the flag for whether this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @param    output
+    *           {@code true} if this is OUTPUT or INPUT-OUTPUT.
+    */
+   public void setOutputMode(boolean output)
+   {
+      this.output = output;
+   }
+
+   /**
     * Determines if this is a remote parameter.
     *
-    * @return <code>true</code> if this is a remote parameter, <code>false</code> if this is a
-    *         local parameter.
+    * @return   {@code true} if this is a remote parameter, {@code false} if this is a
+    *           local parameter.
     */
    public boolean isRemoteParameter()
    {
@@ -287,9 +360,9 @@
    }
 
    /**
-    * Get result set (for remote parameters).
+    * Get the result set (for remote parameters).
     *
-    * @return Result set.
+    * @return   Result set.
     */
    public TableWrapper getResultSet()
    {
@@ -297,10 +370,10 @@
    }
 
    /**
-    * Set result set (for remote parameters).
+    * Set the result set (for remote parameters).
     *
-    * @param resultSet
-    *        Result set, normally containing output data.
+    * @param    resultSet
+    *           Result set, normally containing output data.
     */
    public void setResultSet(TableWrapper resultSet)
    {
@@ -308,9 +381,9 @@
    }
 
    /**
-    * Get the handle which references the wrapped table.
+    * Get the table-handle which references the wrapped table.
     *
-    * @return  handle to the wrapped table.
+    * @return   The table-handle (contains the wrapped table).
     */
    public handle getTableHandle()
    {
@@ -331,7 +404,7 @@
    /**
     * Get the buffer of the wrapped table.
     *
-    * @return  buffer of the wrapped table.
+    * @return   buffer of the wrapped table.
     */
    public Temporary getTable()
    {
@@ -356,57 +429,57 @@
    /**
     * Determines if the APPEND option was specified on the calling side.
     *
-    * @return <code>true</code> if the APPEND option was specified on the calling side.
+    * @return    {@code true} if the APPEND option was specified on the calling side.
     */
    public boolean isAppend()
    {
-      return append;
+      return option == ParameterOption.APPEND;
    }
    
    /**
     * Determines if the {@code BY-VALUE} option was specified on the calling side.
     *
-    * @return  {@code true} if the {@code BY-VALUE} option was specified on the calling side.
+    * @return   {@code true} if the {@code BY-VALUE} option was specified on the calling side.
     */
    public boolean isByValue()
    {
-      return mode == ParameterOption.BY_VALUE;
+      return option == ParameterOption.BY_VALUE;
    }
    
    /**
     * Determines if the {@code BIND} option was specified on the calling side.
     *
-    * @return  {@code true} if the {@code BIND} option was specified on the calling side.
+    * @return   {@code true} if the {@code BIND} option was specified on the calling side.
     */
    public boolean isBind()
    {
-      return mode == ParameterOption.BIND;
+      return option == ParameterOption.BIND;
    }
    
    /**
     * Determines if the {@code BY-REFERENCE} option was specified on the calling side.
     *
-    * @return  {@code true} if the {@code BY-REFERENCE} option was specified on the calling side.
+    * @return   {@code true} if the {@code BY-REFERENCE} option was specified on the calling side.
     */
    public boolean isByReference()
    {
-      return mode == ParameterOption.BY_REFERENCE;
+      return option == ParameterOption.BY_REFERENCE;
    }
    
    /**
-    * Get the parameter passing mode for this argument.
+    * Get the table parameter option for this argument.
     * 
-    * @return   The parameter passing {@link #mode}.
+    * @return   The table parameter option.
     */
-   public ParameterOption getParameterMode()
+   public ParameterOption getParameterOption()
    {
-      return mode;
+      return option;
    }
    
    /**
     * Get 1-based index of the table parameter (in declaration of the function).
     *
-    * @return 1-based index of the table parameter or <code>0</code> if it is not defined.
+    * @return    1-based index of the table parameter or <code>0</code> if it is not defined.
     */
    public int getParameterIndex()
    {
@@ -416,8 +489,8 @@
    /**
     * Set 1-based index of the table parameter (in declaration of the function).
     *
-    * @param parameterIndex
-    *        1-based index of the table parameter.
+    * @param    parameterIndex
+    *           1-based index of the table parameter.
     */
    public void setParameterIndex(int parameterIndex)
    {

